diff --git a/src/bridge.c b/src/bridge.c
index 507b108dc..d4fef3c5d 100644
--- a/src/bridge.c
+++ b/src/bridge.c
@@ -1,7 +1,21 @@
 /*
- * Handing bridge interfaces.
+ *	bridge interface handling
  *
- * Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2012-2023 SUSE LLC
+ *
+ *	This program is free software; you can redistribute it and/or modify
+ *	it under the terms of the GNU General Public License as published by
+ *	the Free Software Foundation; either version 2 of the License, or
+ *	(at your option) any later version.
+ *
+ *	This program is distributed in the hope that it will be useful,
+ *	but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *	GNU General Public License for more details.
+ *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifdef HAVE_CONFIG_H
 #include "config.h"
@@ -14,215 +28,75 @@
 #include "util_priv.h"
 #include "limits.h"
 
-#define NI_BRIDGE_PORT_ARRAY_CHUNK	16
+#include <linux/if_bridge.h>
 
-static void			ni_bridge_port_array_init(ni_bridge_port_array_t *);
-static void			ni_bridge_port_array_destroy(ni_bridge_port_array_t *);
-static void			__ni_bridge_port_array_realloc(ni_bridge_port_array_t *,
-					unsigned int);
-static int			__ni_bridge_port_array_append(ni_bridge_port_array_t *,
-					ni_bridge_port_t *);
 
-
-ni_bridge_port_t *
-ni_bridge_port_new(ni_bridge_t *bridge, const char *ifname, unsigned int ifindex)
+static ni_bool_t
+ni_bridge_port_config_init(ni_bridge_port_config_t *conf)
 {
-	ni_bridge_port_t *port;
-
-	port = xcalloc(1, sizeof(ni_bridge_port_t));
-	ni_string_dup(&port->ifname, ifname);
-	port->ifindex = ifindex;
-	/* apply "not set" defaults */
-	port->priority = NI_BRIDGE_VALUE_NOT_SET;
-	port->path_cost = NI_BRIDGE_VALUE_NOT_SET;
-
-	if (bridge)
-		__ni_bridge_port_array_append(&bridge->ports, port);
-	return port;
-}
-
-ni_bridge_port_t *
-ni_bridge_port_clone(const ni_bridge_port_t *src)
-{
-	ni_bridge_port_t *dst;
-
-	if (src) {
-		dst = ni_bridge_port_new(NULL, src->ifname, src->ifindex);
-		dst->priority = src->priority;
-		dst->path_cost = src->path_cost;
-		return dst;
+	if (conf) {
+		/* apply "not set" defaults */
+		conf->priority = NI_BRIDGE_VALUE_NOT_SET;
+		conf->path_cost = NI_BRIDGE_VALUE_NOT_SET;
+		return TRUE;
 	}
-	return NULL;
-}
-
-void
-ni_bridge_port_free(ni_bridge_port_t *port)
-{
-	ni_string_free(&port->ifname);
-	ni_bridge_port_status_destroy(&port->status);
-	free(port);
+	return FALSE;
 }
 
-static void
-ni_bridge_port_array_init(ni_bridge_port_array_t *array)
+ni_bridge_port_config_t *
+ni_bridge_port_config_new(void)
 {
-	memset(array, 0, sizeof(*array));
-}
+	ni_bridge_port_config_t *conf;
 
-static void
-ni_bridge_port_array_destroy(ni_bridge_port_array_t *array)
-{
-	while (array->count > 0)
-		ni_bridge_port_free(array->data[--array->count]);
-	free(array->data);
-	ni_bridge_port_array_init(array);
-}
+	conf = malloc(sizeof(*conf));
+	if (ni_bridge_port_config_init(conf))
+		return conf;
 
-static void
-__ni_bridge_port_array_realloc(ni_bridge_port_array_t *array, unsigned int newsize)
-{
-	ni_bridge_port_t **newdata;
-	unsigned int i;
-
-	newsize = (newsize + NI_BRIDGE_PORT_ARRAY_CHUNK);
-	newdata = xrealloc(array->data, newsize * sizeof(ni_bridge_port_t));
-	array->data = newdata;
-	for (i = array->count; i < newsize; ++i)
-		array->data[i] = NULL;
-}
-
-static int
-__ni_bridge_port_array_append(ni_bridge_port_array_t *array, ni_bridge_port_t *port)
-{
-	if ((array->count % NI_BRIDGE_PORT_ARRAY_CHUNK) == 0)
-		__ni_bridge_port_array_realloc(array, array->count);
-
-	array->data[array->count++] = port;
-	return 0;
+	free(conf);
+	return NULL;
 }
 
-static int
-ni_bridge_port_array_remove_index(ni_bridge_port_array_t *array, unsigned int pos)
+void
+ni_bridge_port_config_free(ni_bridge_port_config_t *conf)
 {
-	unsigned int i;
-
-	if (pos >= array->count)
-		return -1;
-
-	ni_bridge_port_free(array->data[pos]);
-	/* make it less cumbersome... */
-	array->data[pos] = NULL;
-	for (i = pos + 1; i < array->count; ++i) {
-		array->data[i - 1] = array->data[i];
-		array->data[i] = NULL;
-	}
-	array->count--;
-	return 0;
+	ni_bridge_port_config_init(conf);
+	free(conf);
 }
 
-/*
- * Locate a port given its name or index
- */
-ni_bridge_port_t *
-ni_bridge_port_by_index(const ni_bridge_t *bridge, unsigned int ifindex)
+static ni_bool_t
+ni_bridge_port_info_init(ni_bridge_port_info_t *info)
 {
-	ni_bridge_port_t **pp, *port;
-	unsigned int i;
-
-	for (i = 0, pp = bridge->ports.data; i < bridge->ports.count; ++i) {
-		port = *pp++;
-		if (port->ifindex == ifindex)
-			return port;
+	if (info) {
+		memset(info, 0, sizeof(*info));
+		/* apply "not set" defaults */
+		info->priority = NI_BRIDGE_VALUE_NOT_SET;
+		info->path_cost = NI_BRIDGE_VALUE_NOT_SET;
+		return TRUE;
 	}
-	return NULL;
+	return FALSE;
 }
 
-ni_bridge_port_t *
-ni_bridge_port_by_name(const ni_bridge_t *bridge, const char *ifname)
+ni_bridge_port_info_t *
+ni_bridge_port_info_new(void)
 {
-	ni_bridge_port_t **pp, *port;
-	unsigned int i;
+	ni_bridge_port_info_t *info;
 
-	if (ifname == NULL)
-		return NULL;
+	info = malloc(sizeof(*info));
+	if (ni_bridge_port_info_init(info))
+		return info;
 
-	for (i = 0, pp = bridge->ports.data; i < bridge->ports.count; ++i) {
-		port = *pp++;
-		if (ni_string_eq(port->ifname, ifname))
-			return port;
-	}
+	free(info);
 	return NULL;
 }
 
-/*
- * Add a port to the bridge configuration
- * Note, in case of success, the bridge will have taken ownership of the port object.
- */
-int
-ni_bridge_add_port(ni_bridge_t *bridge, ni_bridge_port_t *port)
-{
-	if (!port)
-		return -1;
-
-	if (port->ifindex && ni_bridge_port_by_index(bridge, port->ifindex))
-		return -1;
-	if (port->ifname && ni_bridge_port_by_name(bridge, port->ifname))
-		return -1;
-
-	__ni_bridge_port_array_append(&bridge->ports, port);
-	return 0;
-}
-
-
-int
-ni_bridge_del_port(ni_bridge_t *bridge, unsigned int pos)
-{
-	return ni_bridge_port_array_remove_index(&bridge->ports, pos);
-}
-
-int
-ni_bridge_del_port_ifname(ni_bridge_t *bridge, const char *ifname)
-{
-	ni_bridge_port_t **pp, *port;
-	unsigned int i;
-
-	for (i = 0, pp = bridge->ports.data; i < bridge->ports.count; ++i) {
-		port = *pp++;
-		if (ni_string_eq(port->ifname, ifname)) {
-			ni_bridge_port_array_remove_index(&bridge->ports, i);
-			return 0;
-		}
-	}
-	return -1;
-}
-
-int
-ni_bridge_del_port_ifindex(ni_bridge_t *bridge, unsigned int ifindex)
-{
-	ni_bridge_port_t **pp, *port;
-	unsigned int i;
-
-	for (i = 0, pp = bridge->ports.data; i < bridge->ports.count; ++i) {
-		port = *pp++;
-		if (port->ifindex == ifindex) {
-			ni_bridge_port_array_remove_index(&bridge->ports, i);
-			return 0;
-		}
-	}
-	return -1;
-}
-
 void
-ni_bridge_get_port_names(const ni_bridge_t *bridge, ni_string_array_t *names)
+ni_bridge_port_info_free(ni_bridge_port_info_t *info)
 {
-	unsigned int i;
-
-	if (!bridge || !names)
-		return;
-	for (i = 0; i < bridge->ports.count; ++i) {
-		ni_bridge_port_t *port = bridge->ports.data[i];
-		if (port && port->ifname && *port->ifname)
-			ni_string_array_append(names, port->ifname);
+	if (info) {
+		ni_string_free(&info->designated_root);
+		ni_string_free(&info->designated_bridge);
+		ni_bridge_port_info_init(info);
+		free(info);
 	}
 }
 
@@ -257,7 +131,6 @@ ni_bridge_new(void)
 static void
 __ni_bridge_destroy(ni_bridge_t *bridge)
 {
-	ni_bridge_port_array_destroy(&bridge->ports);
 	ni_bridge_status_destroy(&bridge->status);
 }
 
@@ -277,19 +150,6 @@ ni_bridge_status_destroy(ni_bridge_status_t *bs)
 	memset(bs, 0, sizeof(*bs));
 }
 
-void
-ni_bridge_port_status_destroy(ni_bridge_port_status_t *ps)
-{
-	ni_string_free(&ps->designated_root);
-	ni_string_free(&ps->designated_bridge);
-}
-
-void
-ni_bridge_ports_destroy(ni_bridge_t *bridge)
-{
-	ni_bridge_port_array_destroy(&bridge->ports);
-}
-
 /*
  * From IEEE 802.1D-1998, 8.10.2 (STP):
  * 				Recommended	Fixed value	Range
@@ -356,19 +216,22 @@ ni_bridge_ports_destroy(ni_bridge_t *bridge)
 #define NI_BRIDGE_PORT_MAX_COUNT	1024
 
 const char *
-ni_bridge_port_validate(const ni_bridge_port_t *port)
+ni_bridge_port_priority_validate(unsigned int priority)
 {
-	if (!port || !port->ifname)
-		return "uninitialized port configuration";
-
-	if (port->priority != NI_BRIDGE_VALUE_NOT_SET &&
-	    port->priority > NI_BRIDGE_PORT_PRIORITY_MAX)
+	if (priority != NI_BRIDGE_VALUE_NOT_SET &&
+	    priority > NI_BRIDGE_PORT_PRIORITY_MAX)
 		return "bridge port priority is out of supported range (0-63)";
 
-	if (port->path_cost != NI_BRIDGE_VALUE_NOT_SET &&
-	   (port->path_cost < NI_BRIDGE_PORT_PATH_COST_MIN ||
-	    port->path_cost > NI_BRIDGE_PORT_PATH_COST_MAX))
-		return "bridge port priority is out of supported range (0-65535)";
+	return NULL;
+}
+
+const char *
+ni_bridge_port_path_cost_validate(unsigned int path_cost)
+{
+	if (path_cost != NI_BRIDGE_VALUE_NOT_SET &&
+	    (path_cost < NI_BRIDGE_PORT_PATH_COST_MIN ||
+	     path_cost > NI_BRIDGE_PORT_PATH_COST_MAX))
+		return "bridge port path-cost is out of supported range (0-65535)";
 
 	return NULL;
 }
@@ -376,8 +239,6 @@ ni_bridge_port_validate(const ni_bridge_port_t *port)
 const char *
 ni_bridge_validate(const ni_bridge_t *bridge)
 {
-	unsigned int i;
-
 	if (!bridge)
 		return "uninitialized bridge configuration";
 
@@ -422,15 +283,6 @@ ni_bridge_validate(const ni_bridge_t *bridge)
 			return "bridge max-age is out of supported range (0.0-60.0)";
 	}
 
-	if (bridge->ports.count > NI_BRIDGE_PORT_MAX_COUNT)
-		return "bridge port count is higher than supported (0-1024)";
-
-	for (i = 0; i < bridge->ports.count; ++i) {
-		const char *err = ni_bridge_port_validate(bridge->ports.data[i]);
-		if (err != NULL)
-			return err;
-	}
-
 	return NULL;
 }
 
@@ -494,3 +346,23 @@ ni_bridge_waittime_from_xml(const xml_node_t *brnode)
 	waittime = ni_bridge_waittime(&bridge);
 	return waittime;
 }
+
+static const ni_intmap_t	ni_bridge_port_state_map[] = {
+	/*
+	 * just use BR_STATE constants from linux/if_bridge.h;
+	 * br_port_state_names from linux/net/bridge/br_stp.c.
+	 */
+	{ "disabled",		BR_STATE_DISABLED		},
+	{ "listening",		BR_STATE_LISTENING		},
+	{ "learning",		BR_STATE_LEARNING		},
+	{ "forwarding",		BR_STATE_FORWARDING		},
+	{ "blocking",		BR_STATE_BLOCKING		},
+
+	{ NULL,			-1U				}
+};
+
+const char *
+ni_bridge_port_state_name(unsigned int state)
+{
+	return ni_format_uint_mapped(state, ni_bridge_port_state_map);
+}
diff --git a/src/client/ifconfig.h b/src/client/ifconfig.h
index 39639b0ac..ff6ff479c 100644
--- a/src/client/ifconfig.h
+++ b/src/client/ifconfig.h
@@ -2,6 +2,7 @@
  *	wicked client ifconfig structures and objects
  *
  *	Copyright (C) 2010-2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2014-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,24 +14,20 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Pawel Wieczorkiewicz <pwieczorkiewicz@suse.de>
- *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
-#ifndef   __WICKED_CLIENT_IFCONFIG_H__
-#define   __WICKED_CLIENT_IFCONFIG_H__
+#ifndef NI_WICKED_CLIENT_IFCONFIG_H
+#define NI_WICKED_CLIENT_IFCONFIG_H
 
 #define NI_CONFIG_ORIGIN			"origin"
+#define NI_CONFIG_OWNER				"owner"
 #define NI_CONFIG_UUID				"uuid"
 
 #define NI_CLIENT_IFCONFIG			"interface"
-#define NI_CLIENT_IFCONFIG_UUID			NI_CONFIG_UUID
 #define NI_CLIENT_IFCONFIG_ORIGIN		NI_CONFIG_ORIGIN
+#define NI_CLIENT_IFCONFIG_OWNER		NI_CONFIG_OWNER
+#define NI_CLIENT_IFCONFIG_UUID			NI_CONFIG_UUID
 #define NI_CLIENT_IFCONFIG_MATCH_NAME		"name"
 #define NI_CLIENT_IFCONFIG_CONTROL		"control"
 #define NI_CLIENT_IFCONFIG_MODE			"mode"
@@ -60,11 +57,11 @@
 #define NI_NANNY_IFPOLICY_REPLACE		"replace"
 #define NI_NANNY_IFPOLICY_CREATE		"create"
 
-#define NI_NANNY_IFPOLICY_UUID			NI_CONFIG_UUID
 #define NI_NANNY_IFPOLICY_ORIGIN		NI_CONFIG_ORIGIN
-#define NI_NANNY_IFPOLICY_NAME			"name"
-#define NI_NANNY_IFPOLICY_OWNER			"owner"
+#define NI_NANNY_IFPOLICY_OWNER			NI_CONFIG_OWNER
+#define NI_NANNY_IFPOLICY_UUID			NI_CONFIG_UUID
 #define NI_NANNY_IFPOLICY_WEIGHT		"weight"
+#define NI_NANNY_IFPOLICY_NAME			"name"
 
 extern ni_bool_t		ni_ifpolicy_match_add_min_state(xml_node_t *, unsigned int);
 extern ni_bool_t		ni_ifpolicy_match_add_link_type(xml_node_t *, unsigned int);
@@ -93,10 +90,12 @@ extern ni_bool_t		ni_nanny_call_add_secret(const ni_security_id_t *, const char
 extern ni_bool_t		ni_nanny_call_recheck(const ni_string_array_t *);
 
 extern ni_bool_t		ni_ifconfig_generate_uuid(const xml_node_t *, ni_uuid_t *);
-extern ni_bool_t		ni_ifconfig_migrate(xml_node_t *);
+extern ni_bool_t		ni_ifxml_node_is_migrated(const xml_node_t *);
+extern ni_bool_t		ni_ifxml_node_set_migrated(xml_node_t *, ni_bool_t);
+extern ni_bool_t		ni_ifxml_migrate_docs(xml_document_array_t *);
 
 static inline ni_bool_t
-ni_ifconfig_is_config(xml_node_t *ifnode)
+ni_ifconfig_is_config(const xml_node_t *ifnode)
 {
 	return !xml_node_is_empty(ifnode) && ni_string_eq(ifnode->name, NI_CLIENT_IFCONFIG);
 }
@@ -166,4 +165,4 @@ ni_ifpolicy_is_valid(const xml_node_t *pnode)
 	return ni_ifpolicy_name_is_valid(ni_ifpolicy_get_name(pnode));
 }
 
-#endif /* __WICKED_CLIENT_IFCONFIG_H__ */
+#endif /* NI_WICKED_CLIENT_IFCONFIG_H */
diff --git a/src/client/policy.c b/src/client/policy.c
index 0d5d5adab..5f17132af 100644
--- a/src/client/policy.c
+++ b/src/client/policy.c
@@ -2,6 +2,7 @@
  *	wicked client related policy functions
  *
  *	Copyright (C) 2010-2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2014-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,16 +14,9 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Pawel Wieczorkiewicz <pwieczorkiewicz@suse.de>
- *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #include <unistd.h>
 #include <sys/types.h>
 #include <ctype.h>
@@ -301,48 +295,94 @@ ni_convert_cfg_into_policy_node(const xml_node_t *ifcfg, xml_node_t *match, cons
 }
 
 xml_document_t *
-ni_convert_cfg_into_policy_doc(xml_document_t *ifconfig)
+ni_convert_cfg_into_policy_doc(xml_document_t *doc)
 {
-	xml_node_t *root, *ifnode, *ifname, *match;
+	xml_node_t *root, *match, *policy;
 	const char *origin;
+	const char *ifname;
+
+	if (xml_document_is_empty(doc))
+		return NULL;
 
-	if (xml_document_is_empty(ifconfig))
+	root = xml_document_root(doc);
+	if (ni_string_empty(root->name))
 		return NULL;
 
-	root = xml_document_root(ifconfig);
 	origin = xml_node_location_filename(root);
+	if (ni_string_empty(origin))
+		return NULL;
 
-	for (ifnode = root->children; ifnode; ifnode = ifnode->next) {
-		if (ni_ifpolicy_is_valid(ifnode)) {
-			const char *name = ni_ifpolicy_get_name(ifnode);
-			ni_debug_ifconfig("Ignoring already existing %s named %s from %s",
+	if (ni_ifpolicy_is_valid(root)) {
+		const char *name = ni_ifpolicy_get_name(root);
+
+		ni_debug_ifconfig("Ignoring already existing %s named %s from %s",
 				NI_NANNY_IFPOLICY, name, origin);
-			continue;
-		}
-		else if (ni_ifconfig_is_policy(ifnode)) {
-			ni_debug_ifconfig("Ignoring already existing, noname %s from %s",
+		return doc;
+	} else if (ni_ifconfig_is_policy(root)) {
+		ni_debug_ifconfig("Ignoring already existing, noname %s from %s",
 				NI_NANNY_IFPOLICY, origin);
-			continue;
-		}
+		return doc;
+	}
 
-		if (!ni_ifconfig_is_config(ifnode)) {
-			ni_error("Invalid object found in file %s: neither an %s nor %s",
-				origin, NI_CLIENT_IFCONFIG, NI_NANNY_IFPOLICY);
-			return NULL;
-		}
+	if (!ni_ifconfig_is_config(root)) {
+		ni_error("Invalid object found in file %s: neither an %s nor %s",
+			origin, NI_CLIENT_IFCONFIG, NI_NANNY_IFPOLICY);
+		return NULL;
+	}
+
+	ifname = xml_node_get_child_cdata(root, NI_CLIENT_IFCONFIG_MATCH_NAME);
+	if (ni_string_empty(ifname))
+		return NULL;
 
-		ifname = xml_node_get_child(ifnode, NI_CLIENT_IFCONFIG_MATCH_NAME);
-		if (!ifname || ni_string_empty(ifname->cdata))
-			return NULL;
+	if (!(match = xml_node_new(NI_NANNY_IFPOLICY_MATCH, NULL)))
+		return NULL;
 
-		if (!(match = ni_ifpolicy_generate_match(NULL, NULL)))
-			return NULL;
+	if (!xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, match, ifname)) {
+		xml_node_free(match);
+		return NULL;
+	}
 
-		xml_node_add_child(root,
-			ni_convert_cfg_into_policy_node(ifnode, match, ifname->cdata, origin));
+	policy = ni_convert_cfg_into_policy_node(root, match, ifname, origin);
+	if (policy) {
+		xml_node_location_relocate(policy, origin);
+		xml_document_set_root(doc, policy);
+		xml_node_free(match);
+		return doc;
 	}
+	xml_node_free(match);
+	return NULL;
+}
+
+ni_bool_t
+ni_ifxml_node_is_migrated(const xml_node_t *node)
+{
+	ni_bool_t migrated = FALSE;
+	const char *value;
+
+	while (node && node->parent && !ni_string_empty(node->parent->name))
+		node = node->parent;
+
+	value = xml_node_get_attr(node, "migrated");
+	if (ni_parse_boolean(value, &migrated) != 0)
+		return FALSE;
+
+	return migrated;
+}
+
+ni_bool_t
+ni_ifxml_node_set_migrated(xml_node_t *node, ni_bool_t migrated)
+{
+	const char *value;
+
+	while (node && node->parent && !ni_string_empty(node->parent->name))
+		node = node->parent;
+
+	xml_node_del_attr(node, "migrated");
+	if (!migrated)
+		return TRUE;
 
-	return ifconfig;
+	value = ni_format_boolean(TRUE);
+	return xml_node_add_attr(node, "migrated", value);
 }
 
 static ni_bool_t
@@ -466,7 +506,8 @@ ni_ifconfig_migrate_ethtool(xml_node_t *ethernet, xml_node_t *ethtool)
 }
 
 static ni_bool_t
-ni_ifconfig_migrate_ethernet_node(xml_node_t *config, xml_node_t *ethernet)
+ni_ifconfig_migrate_ethernet_node(xml_document_array_t *docs,
+		xml_node_t *config, xml_node_t *ethernet)
 {
 	ni_bool_t modified = FALSE;
 	xml_node_t *ethtool;
@@ -498,7 +539,8 @@ ni_ifconfig_migrate_wireless_network(xml_node_t *network)
 }
 
 static ni_bool_t
-ni_ifconfig_migrate_wireless_node(xml_node_t *config, xml_node_t *wireless)
+ni_ifconfig_migrate_wireless_node(xml_document_array_t *docs,
+		xml_node_t *config, xml_node_t *wireless)
 {
 	ni_bool_t modified = FALSE;
 	xml_node_t *networks;
